/*
**	litexm.h - xmodem engine for litecomm - header file
**			   Copyright (c) 1987, 1988 - Information Technology, Ltd.
*/

/*
**	ASCII and XMODEM control characters
*/

#define SOH 1					/* start of header */
#define STX 2                   /* start of text - YModem variant */
#define EOT 4					/* end of transmission */
#define ACK 6					/* true acknowledge */
#define NAK 0x15				/* false acknowledge */
#define DLE 0x10                /* DLE char for WXmodem */
#define SYN 0x16                /* SYN char for WXmodem */
#define CRC 'C'					/* request CRC mode */
#define CAN 0x18				/* cancel transmission */

/*
**	User accessable system equates
*/

#define RETRY        25                 /* no. of retrys before abort */
#define RECSIZE      128                /* transfer record size */
#define NORMAL         1                /* normal xmodem timeouts */
#define RELAXED        2                /* relaxed (longer) timeouts */

/*
** additional constants used for return codes from xmodem
** routines
*/
#define SUCCESS		('S')
#define RETRIES		('R')
#define TOUT		('T')
#define RESEND          ('E')
#define DUPSEQ		('D')

/*
**  globals in lxmkrnl.c
*/

extern int _abort_flag;                 /* abort flag, set by user */
extern int crc;                         /* CRC mode flag */
extern unsigned rec;                    /* record number */
extern unsigned char checksum;          /* checksum accumulator */
extern unsigned crcaccum;               /* global crc bytes */
extern int ymodem;						/* true if sending YModem */

/*
** function prototypes
*/

int wait(int, int);
void updcrc(unsigned char);
void purge(unsigned);
int lcxtrec(unsigned, unsigned char *);
int lcxteot(unsigned);
int lcxrrec(unsigned,unsigned char *,int *, int,unsigned char *);
int lwxtrec(unsigned, unsigned char *, int *);
int lwxrrec(unsigned, unsigned char *);
